code/run-time/samples/cardemo/src/main/java/carstore/CarBean.java
/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at
 * https://javaserverfaces.dev.java.net/CDDL.html or
 * legal/CDDLv1.0.txt. 
 * See the License for the specific language governing
 * permission and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at legal/CDDLv1.0.txt.    
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * [Name of File] [ver.__] [Date]
 * 
 * Copyright 2005 Sun Microsystems Inc. All Rights Reserved
 */


package carstore;

import javax.faces.application.Application;
import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.component.UISelectItems;
import javax.faces.component.ValueHolder;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.model.SelectItem;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import java.util.List;
import java.util.Collection;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * <p>This bean encapsulates a car model, including pricing and package
 * choices.  The system allows the user to customize the properties of
 * this bean with the help of the {@link CarCustomizer}.</p>
 * <p/>
 * <h3>Data Access</h3>
 * <p/>
 * <p>This is the only bean in the system that has complicated access to
 * the persistent store of data.  In the present implementation, this
 * persistent store is in <code>ResourceBundle</code> instances.</p>
 * <p/>
 * <p>There are three data source <code>ResourceBundle</code> files
 * used:</p>
 * <p/>
 * <ol>
 * <p/>
 * <li><p><code>&lt;ModelName&gt;</code></p>
 * <p/>
 * <p>This contains the localized content for this model.  There
 * is a variant of this file for each supported locale, for
 * example, <code>Jalopy_de.properties</code></p>
 * <p/>
 * </li>
 * <p/>
 * <li><p><code>&lt;Common_properties&gt;</code></p>
 * <p/>
 * <p>This contains the localized content common to all
 * models.</p>
 * <p/>
 * </li>
 * <p/>
 * <li><p><code>&lt;ModelName_options&gt;</code></p>
 * <p/>
 * <p>This contains the non-localized content for this model,
 * including the non-localized options.  There is only one
 * variant of this file for all locales for example,
 * <code>Jalopy_options.properties</code></p>
 * <p/>
 * </li>
 * <p/>
 * </ol>
 * <p/>
 * <p>All files conform to the following convention:</p>
 * <p/>
 * <code><pre>
 * key
 * key_componentType
 * key_valueType
 * </pre></code>
 * <p/>
 * <p>Where <code>key</code> is the name of an attribute of this car.
 * For example, <code>basePrice</code>, or <code>description</code>.
 * <code>key_componentType</code> is the component type of the
 * <code>UIComponent</code> subclass to be used to represent this
 * attribute in the page, for example <code>SelectManyMenu</code>.
 * <code>key_valueType</code> is the data type of the value of the
 * <code>UIComponent</code>, for example <code>java.lang.Integer</code>.
 * For all non-String valueTypes.</p>
 * <p/>
 * <p>When the bean is instantiated, we load both of the above
 * properties files and iterate over the keys in each one.  For each
 * key, we look at the <code>componentType</code> and ask the
 * <code>Application</code> to create a component of that type.  We
 * store that <code>UIComponent</code> instance in our
 * <code>components</code> <code>Map</code> under the name
 * <code>key</code>.  We look at the <code>valueType</code> for the
 * <code>key</code>.  For non <code>java.lang.String</code> types, we
 * ask the <code>Application</code> for a <code>Converter</code>
 * instance for that class.  If found, we use it to convert the value
 * for the <code>key</code> to the appropriate type and store that as
 * the <code>value</code> of the <code>UIComponent</code> instance.</p>
 */

public class CarBean {

    private static final Logger LOGGER = Logger.getLogger("carstore");

    /**
     * <p>The message identifier of the Message to be created if
     * the conversion fails.  The message format string for this
     * message may optionally include a <code>{0}</code>
     * placeholder, which will be replaced by the object and value.</p>
     */
    public static final String CONVERTER_ERROR_MESSAGE_ID =
          "carstore.Converter_Error";

    //
    // Relationship Instance Variables
    //

    /** Localized labels */

    private ResourceBundle resources = null;

    /** Price data */
    private ResourceBundle priceData = null;

    /**
     * Keys: String attribute name, such as engine. Values: UIComponent
     * for the attribute
     */

    private Map<String, UIComponent> components = null;

    /**
     * Keys: String attribute name, such as engine. Values: String value
     * of the component named by key in our components Map.
     */

    private Map<String,Object> attributes = null;

    // 
    // Constructors
    //

    public CarBean() {
        this.init(CarStore.DEFAULT_MODEL_PROPERTIES);
    }


    public CarBean(String bundleName) {
        this.init(bundleName);
    }


    /**
     * <p>Initialize our components <code>Map</code> as described in the
     * class documentation.</p>
     * <p/>
     * <p>Create a wrapper <code>Map</code> around the components
     * <code>Map</code> that exposes the String converted value of each
     * component.</p>
     * 
     * @param bundleName the resource bundle name
     */
    private void init(String bundleName) {
        FacesContext context = FacesContext.getCurrentInstance();       

        components = new HashMap<String, UIComponent>();

        // load the labels
        resources =
              ResourceBundle.getBundle(CarStore.CARSTORE_PREFIX +
                                       ".bundles.Resources",
                                       context.getViewRoot().getLocale());

        // load the prices
        priceData = ResourceBundle.getBundle(CarStore.CARSTORE_PREFIX +
                                             ".bundles.OptionPrices");

        // populate the locale-specific information
        if (LOGGER.isLoggable(Level.FINE)) {
            LOGGER.fine("Loading bundle: " + bundleName + ".");
        }
        ResourceBundle data = ResourceBundle.getBundle(bundleName,
                                        context.getViewRoot().getLocale());
        if (LOGGER.isLoggable(Level.FINE)) {
            LOGGER.fine("Bundle " + bundleName +
                        " loaded. Reading properties...");
        }
        initComponentsFromProperties(context, data);
        if (LOGGER.isLoggable(Level.FINE)) {
            LOGGER.fine("done.");
        }

        // populate the non-locale-specific information common to all cars
        if (LOGGER.isLoggable(Level.FINE)) {
            LOGGER.fine("Loading bundle: Common_options.");
        }
        data = ResourceBundle.getBundle(CarStore.CARSTORE_PREFIX +
                                        ".bundles.Common_options");
        if (LOGGER.isLoggable(Level.FINE)) {
            LOGGER.fine("Bundle Common_options loaded. Reading properties...");
        }
        initComponentsFromProperties(context, data);
        if (LOGGER.isLoggable(Level.FINE)) {
            LOGGER.fine("done.");
        }

        // populate the non-locale-specific information specific to each car
        if (LOGGER.isLoggable(Level.FINE)) {
            LOGGER.fine("Loading bundle: " + bundleName + "_options.");
        }
        data = ResourceBundle.getBundle(bundleName + "_options");
        if (LOGGER.isLoggable(Level.FINE)) {
            LOGGER.fine("Bundle " + bundleName +
                        "_options loaded. Reading properties...");
        }
        initComponentsFromProperties(context, data);
        if (LOGGER.isLoggable(Level.FINE)) {
            LOGGER.fine("done.");
        }

        // create a read-only Map exposing the values of all of our
        // components.
        attributes =
            new Map() {
                public void clear() {
                    CarBean.this.components.clear();
                }


                public boolean containsKey(Object key) {
                    return CarBean.this.components.containsKey(key);
                }


                public boolean containsValue(Object value) {
                    throw new UnsupportedOperationException();
                }


                public java.util.Set<Map.Entry<String,Object>> entrySet() {
                    throw new UnsupportedOperationException();
                }


                public boolean equals(Object o) {
                    throw new UnsupportedOperationException();
                }


                public Object get(Object key) {
                    UIComponent component;
                    Converter converter = null;
                    Object result = null;
                    if (null == key) {
                        return null;
                    }
                    if (null != (component = 
                        CarBean.this.components.get(key))) {
                        // if this component can have a Converter
                        if (component instanceof ValueHolder) {
                            // try to get it
                            converter = ((ValueHolder) component).
                                getConverter();
                            result = ((ValueHolder) component).getValue();
                        }

code/run-time/samples/cardemo/src/main/java/carstore/CustomerBean.java
/*
 * $Id: CustomerBean.java,v 1.3 2006/03/09 01:17:29 rlubke Exp $
 */
/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at
 * https://javaserverfaces.dev.java.net/CDDL.html or
 * legal/CDDLv1.0.txt. 
 * See the License for the specific language governing
 * permission and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at legal/CDDLv1.0.txt.    
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * [Name of File] [ver.__] [Date]
 * 
 * Copyright 2005 Sun Microsystems Inc. All Rights Reserved
 */

package carstore;

import javax.faces.context.FacesContext;
import javax.faces.model.SelectItem;

import java.util.ArrayList;
import java.util.Collection;
import java.util.ResourceBundle;
import javax.faces.component.UIViewRoot;

public class CustomerBean {


    private String firstName = null;
    private String middleInitial = null;
    private String lastName = null;
    private String mailingAddress = null;
    private String city = null;
    private String state = null;
    private String zip = null;
    private String month = null;
    private String year = null;


    public CustomerBean() {
        super();
    }


    protected Collection<SelectItem> titleOptions = null;


    public Collection getTitleOptions() {
        titleOptions = new ArrayList<SelectItem>(3);
        UIViewRoot root = FacesContext.getCurrentInstance().getViewRoot();
        ResourceBundle rb = null;

        if (null != root) {
            rb = ResourceBundle.getBundle("carstore.bundles.Resources",
                    root.getLocale());
        }
        if (null != rb) {
            String titleStr = (String) rb.getObject("mrLabel");
            titleOptions.add(new SelectItem(titleStr, titleStr,
                    titleStr));
            titleStr = (String) rb.getObject("mrsLabel");
            titleOptions.add(new SelectItem(titleStr, titleStr,
                    titleStr));
            titleStr = (String) rb.getObject("msLabel");
            titleOptions.add(new SelectItem(titleStr, titleStr,
                    titleStr));
        }

        return titleOptions;
    }


    public void setTitleOptions(Collection<SelectItem> newOptions) {
        titleOptions = new ArrayList<SelectItem>(newOptions);
    }


    String title = null;


    public void setCurrentTitle(String newTitle) {
        title = newTitle;
    }


    public String getCurrentTitle() {
        return title;
    }


    public void setFirstName(String first) {
        firstName = first;
    }


    public String getFirstName() {
        return firstName;
    }


    public void setMiddleInitial(String mI) {
        middleInitial = mI;
    }


    public String getMiddleInitial() {
        return middleInitial;
    }


    public void setLastName(String last) {
        lastName = last;
    }


    public String getLastName() {
        return lastName;
    }


    public void setMailingAddress(String mA) {
        mailingAddress = mA;
    }


    public String getMailingAddress() {
        return mailingAddress;
    }


    public void setCity(String cty) {
        city = cty;
    }


    public String getCity() {
        return city;
    }


    public void setState(String sT) {
        state = sT;
    }


    public String getState() {
        return state;
    }


    public void setZip(String zipCode) {
        zip = zipCode;
    }


    public String getZip() {
        return zip;
    }


    public void setMonth(String mth) {
        month = mth;
    }


    public String getMonth() {
        return month;
    }


    public void setYear(String yr) {
        year = yr;
    }


    public String getYear() {
        return year;
    }
}

code/run-time/samples/cardemo/src/main/webapp/bottomMatter.jsp
<!--
The contents of this file are subject to the terms
of the Common Development and Distribution License
(the License). You may not use this file except in
compliance with the License.

You can obtain a copy of the License at
https://javaserverfaces.dev.java.net/CDDL.html or
legal/CDDLv1.0.txt.
See the License for the specific language governing
permission and limitations under the License.

When distributing Covered Code, include this CDDL
Header Notice in each file and include the License file
at legal/CDDLv1.0.txt.
If applicable, add the following below the CDDL Header,
with the fields enclosed by brackets [] replaced by
your own identifying information:
"Portions Copyrighted [year] [name of copyright owner]"

[Name of File] [ver.__] [Date]

Copyright 2005 Sun Microsystems Inc. All Rights Reserved
-->
<%@ page contentType="text/html" language="java" %>
<%@ taglib prefix="f" uri="http://java.sun.com/jsf/core" %>
<%@ taglib prefix="h" uri="http://java.sun.com/jsf/html" %>


    <a href='<%= request.getContextPath() + "/javadocs" %>'>
        Documentation for this demo
    </a>

code/run-time/samples/cardemo/src/main/webapp/carDetail.jsp
<?xml version="1.0" encoding="UTF-8"?>
<jsp:root version="1.2" 
          xmlns:f="http://java.sun.com/jsf/core"
          xmlns:h="http://java.sun.com/jsf/html"
          xmlns:jsp="http://java.sun.com/JSP/Page"
          xmlns:jsfExt="http://java.sun.com/jsf/extensions/dynafaces">
    <jsp:directive.page contentType="text/html;charset=UTF-8" pageEncoding="UTF-8"/>

<!--
The contents of this file are subject to the terms
of the Common Development and Distribution License
(the License). You may not use this file except in
compliance with the License.

You can obtain a copy of the License at
https://javaserverfaces.dev.java.net/CDDL.html or
legal/CDDLv1.0.txt.
See the License for the specific language governing
permission and limitations under the License.

When distributing Covered Code, include this CDDL
Header Notice in each file and include the License file
at legal/CDDLv1.0.txt.
If applicable, add the following below the CDDL Header,
with the fields enclosed by brackets [] replaced by
your own identifying information:
"Portions Copyrighted [year] [name of copyright owner]"

[Name of File] [ver.__] [Date]

Copyright 2005 Sun Microsystems Inc. All Rights Reserved
-->

<html>

<head>
    <meta http-equiv="Content-Type" content="text/html;CHARSET=UTF-8" />
    <title>CarStore</title>
    <link rel="stylesheet" type="text/css"
          href="${pageContext.request.contextPath}/stylesheet.css" />
</head>

<f:loadBundle basename="carstore.bundles.Resources" var="bundle"/>

<body bgcolor="white">

<f:view>

    <h:form prependId="false">


        <!-- non-option details -->

        <h:panelGrid columns="1"
                     summary="#{bundle.carDetails}"
                     title="#{bundle.carDetails}">

            <h:graphicImage url="/images/cardemo.jpg"/>

            <h:graphicImage
                  binding="#{carstore.currentModel.components.image}"/>

            <h:outputText styleClass="subtitlebig"
                          binding="#{carstore.currentModel.components.title}"/>

            <h:outputText
                  binding="#{carstore.currentModel.components.description}"/>

<jsfExt:ajaxZone id="zone1">

            <h:panelGrid columns="2">

                <h:outputText styleClass="subtitle"
                              value="#{bundle.basePriceLabel}"/>

                <h:outputText
                      binding="#{carstore.currentModel.components.basePrice}"/>

                <h:outputText styleClass="subtitle"
                              value="#{bundle.yourPriceLabel}"/>

                <h:outputText value="#{carstore.currentModel.currentPrice}"/>

            </h:panelGrid>

</jsfExt:ajaxZone>

            <h:commandButton action="#{carstore.buyCurrentCar}"
                             value="#{bundle.buy}"/>

        </h:panelGrid>

        <jsp:include page="optionsPanel.jsp"/>

        <h:commandButton action="#{carstore.buyCurrentCar}"
                         value="#{bundle.buy}"/>

    </h:form>

    <jsp:include page="bottomMatter.jsp"/>

</f:view>
</body>

</html>
</jsp:root>

code/run-time/samples/cardemo/src/main/webapp/customerInfo.jsp
<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<!--
The contents of this file are subject to the terms
of the Common Development and Distribution License
(the License). You may not use this file except in
compliance with the License.

You can obtain a copy of the License at
https://javaserverfaces.dev.java.net/CDDL.html or
legal/CDDLv1.0.txt.
See the License for the specific language governing
permission and limitations under the License.

When distributing Covered Code, include this CDDL
Header Notice in each file and include the License file
at legal/CDDLv1.0.txt.
If applicable, add the following below the CDDL Header,
with the fields enclosed by brackets [] replaced by
your own identifying information:
"Portions Copyrighted [year] [name of copyright owner]"

[Name of File] [ver.__] [Date]

Copyright 2005 Sun Microsystems Inc. All Rights Reserved
-->

<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
    <title>Customer Details</title>
    <link rel="stylesheet" type="text/css"
          href="${pageContext.request.contextPath}/stylesheet.css">

    <%@ taglib uri="http://java.sun.com/jsf/html" prefix="h" %>
    <%@ taglib uri="http://java.sun.com/jsf/core" prefix="f" %>
    <%@ taglib uri="https://javaserverfaces.dev.java.net/demo/carstore"
               prefix="cs" %>
</head>

<body>

<f:loadBundle basename="carstore.bundles.Resources" var="bundle"/>

<f:view>
<h:form prependId="false">

<h:panelGrid id="mainPanel" columns="1" footerClass="subtitle"
             headerClass="subtitlebig" styleClass="medium"
             columnClasses="medium">

<h:graphicImage url="/images/cardemo.jpg"/>

<h:outputText value="#{bundle.customerTitle}"/>

<h:panelGrid id="subPanel" columns="3" footerClass="medium"
             headerClass="subtitlebig" styleClass="medium"
             columnClasses="medium">

<h:outputText value="#{bundle.titleLabel}"/>
<h:selectOneMenu id="title" value="#{customer.currentTitle}">
    <f:selectItems value="#{customer.titleOptions}"/>
</h:selectOneMenu>
<h:outputText value=""/>

<h:outputText value="#{bundle.firstLabel}"/>
<h:inputText id="firstName" value="#{customer.firstName}" required="true">
    <f:valueChangeListener type="carstore.FirstNameChanged"/>
</h:inputText>
<h:message styleClass="validationMessage" for="firstName"/>

<h:outputText value="#{bundle.middleLabel}"/>
<h:inputText id="middleInitial" size="1" maxlength="1"
             value="#{customer.middleInitial}">
</h:inputText>
<h:message styleClass="validationMessage" for="middleInitial"/>

<h:outputText value="#{bundle.lastLabel}"/>
<h:inputText value="#{customer.lastName}"/>
<h:outputText value=""/>

<h:outputText value="#{bundle.mailingLabel}"/>
<h:inputText value="#{customer.mailingAddress}"/>
<h:outputText value=""/>

<h:outputText value="#{bundle.cityLabel}"/>
<h:inputText value="#{customer.city}"/>
<h:outputText value=""/>

<h:outputText value="#{bundle.stateLabel}"/>
<h:selectOneMenu value="#{customer.state}">

    <f:selectItem itemValue="AL" itemLabel="AL"/>
    <f:selectItem itemValue="AK" itemLabel="AK"/>
    <f:selectItem itemValue="AZ" itemLabel="AZ"/>
    <f:selectItem itemValue="AR" itemLabel="AR"/>
    <f:selectItem itemValue="CA" itemLabel="CA"/>
    <f:selectItem itemValue="CO" itemLabel="CO"/>
    <f:selectItem itemValue="CT" itemLabel="CT"/>
    <f:selectItem itemValue="DE" itemLabel="DE"/>
    <f:selectItem itemValue="FL" itemLabel="FL"/>
    <f:selectItem itemValue="GA" itemLabel="GA"/>

    <f:selectItem itemValue="HI" itemLabel="HI"/>
    <f:selectItem itemValue="ID" itemLabel="ID"/>
    <f:selectItem itemValue="IL" itemLabel="IL"/>
    <f:selectItem itemValue="IN" itemLabel="IN"/>
    <f:selectItem itemValue="IA" itemLabel="IA"/>
    <f:selectItem itemValue="KS" itemLabel="KS"/>
    <f:selectItem itemValue="KY" itemLabel="KY"/>
    <f:selectItem itemValue="LA" itemLabel="LA"/>
    <f:selectItem itemValue="ME" itemLabel="ME"/>
    <f:selectItem itemValue="MD" itemLabel="MD"/>

    <f:selectItem itemValue="MA" itemLabel="MA"/>
    <f:selectItem itemValue="MI" itemLabel="MI"/>
    <f:selectItem itemValue="MN" itemLabel="MN"/>
    <f:selectItem itemValue="MO" itemLabel="MO"/>
    <f:selectItem itemValue="MT" itemLabel="MT"/>
    <f:selectItem itemValue="NE" itemLabel="NE"/>
    <f:selectItem itemValue="NV" itemLabel="NV"/>
    <f:selectItem itemValue="NH" itemLabel="NH"/>
    <f:selectItem itemValue="NJ" itemLabel="NJ"/>
    <f:selectItem itemValue="NM" itemLabel="NM"/>

    <f:selectItem itemValue="MY" itemLabel="MY"/>
    <f:selectItem itemValue="NC" itemLabel="NC"/>
    <f:selectItem itemValue="ND" itemLabel="ND"/>
    <f:selectItem itemValue="OH" itemLabel="OH"/>
    <f:selectItem itemValue="OK" itemLabel="OK"/>
    <f:selectItem itemValue="OR" itemLabel="OR"/>
    <f:selectItem itemValue="PA" itemLabel="PA"/>
    <f:selectItem itemValue="RI" itemLabel="RI"/>
    <f:selectItem itemValue="SC" itemLabel="SC"/>
    <f:selectItem itemValue="SD" itemLabel="SD"/>

    <f:selectItem itemValue="TN" itemLabel="TN"/>
    <f:selectItem itemValue="TX" itemLabel="TX"/>
    <f:selectItem itemValue="UT" itemLabel="UT"/>
    <f:selectItem itemValue="VT" itemLabel="VT"/>
    <f:selectItem itemValue="VA" itemLabel="VA"/>
    <f:selectItem itemValue="WA" itemLabel="WA"/>
    <f:selectItem itemValue="WV" itemLabel="WV"/>
    <f:selectItem itemValue="WI" itemLabel="WI"/>
    <f:selectItem itemValue="WY" itemLabel="WY"/>
</h:selectOneMenu>
<h:outputText value=""/>

<h:outputText value="#{bundle.zipLabel}"/>
<h:inputText id="zip"
             value="#{customer.zip}"
             size="10" required="true">
    <cs:format_validator formatPatterns="99999|99999-9999|### ###"/>
</h:inputText>
<h:message styleClass="validationMessage" for="zip"/>

<h:outputText value="#{bundle.ccNumberLabel}"/>
<h:inputText id="ccno" size="16"
             converter="creditCardConverter" required="true">
    <cs:format_validator
          formatPatterns="9999999999999999|9999 9999 9999 9999|9999-9999-9999-9999"/>
</h:inputText>
<h:message styleClass="validationMessage" for="ccno"/>

<h:outputText value="#{bundle.monthLabel}"/>
<h:panelGrid id="monthYearPanel" columns="2" footerClass="medium"
             headerClass="medium" styleClass="medium" columnClasses="medium">
    <h:selectOneMenu value="#{customer.month}">
        <f:selectItem itemValue="01" itemLabel="01"/>
        <f:selectItem itemValue="02" itemLabel="02"/>
        <f:selectItem itemValue="03" itemLabel="03"/>
        <f:selectItem itemValue="04" itemLabel="04"/>
        <f:selectItem itemValue="05" itemLabel="05"/>
        <f:selectItem itemValue="06" itemLabel="06"/>
        <f:selectItem itemValue="07" itemLabel="07"/>
        <f:selectItem itemValue="08" itemLabel="08"/>
        <f:selectItem itemValue="09" itemLabel="09"/>
        <f:selectItem itemValue="10" itemLabel="10"/>
        <f:selectItem itemValue="11" itemLabel="11"/>
        <f:selectItem itemValue="12" itemLabel="12"/>
    </h:selectOneMenu>

    <h:selectOneMenu value="#{customer.year}">
        <f:selectItem itemValue="2002" itemLabel="2002"/>
        <f:selectItem itemValue="2003" itemLabel="2003"/>
        <f:selectItem itemValue="2004" itemLabel="2004"/>
        <f:selectItem itemValue="2005" itemLabel="2005"/>
        <f:selectItem itemValue="2006" itemLabel="2006"/>
        <f:selectItem itemValue="2007" itemLabel="2007"/>
        <f:selectItem itemValue="2008" itemLabel="2008"/>
    </h:selectOneMenu>
</h:panelGrid>
<h:outputText value=""/>

</h:panelGrid>

<h:commandButton value="#{bundle.finishButton}" action="finish"/>

<h:graphicImage id="duke" url="/images/duke.gif"/>

<h:outputText value="#{bundle.buyLabel}"/>

</h:panelGrid>

</h:form>
</f:view>
</body>
</html>

code/run-time/samples/cardemo/src/main/webapp/finish.jsp
<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<!--
The contents of this file are subject to the terms
of the Common Development and Distribution License
(the License). You may not use this file except in
compliance with the License.

You can obtain a copy of the License at
https://javaserverfaces.dev.java.net/CDDL.html or
legal/CDDLv1.0.txt.
See the License for the specific language governing
permission and limitations under the License.

When distributing Covered Code, include this CDDL
Header Notice in each file and include the License file
at legal/CDDLv1.0.txt.
If applicable, add the following below the CDDL Header,
with the fields enclosed by brackets [] replaced by
your own identifying information:
"Portions Copyrighted [year] [name of copyright owner]"

[Name of File] [ver.__] [Date]

Copyright 2005 Sun Microsystems Inc. All Rights Reserved
-->

<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h" %>
<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f" %>

<html>

<head>
    <title>Welcome to CarStore</title>
    <link rel="stylesheet" type="text/css"
          href="${pageContext.request.contextPath}/stylesheet.css">
</head>

<body bgcolor="white">
<f:loadBundle basename="carstore.bundles.Resources" var="bundle"/>
<f:view>
    <h:form>
        <h:graphicImage url="/images/cardemo.jpg"/>

        <h:panelGrid id="thanksPanel" columns="1" footerClass="subtitle"
                     headerClass="subtitlebig" styleClass="medium"
                     columnClasses="subtitle,medium">
            <f:facet name="header">
                <h:outputFormat title="thanks" value="#{bundle.thanksLabel}">
                    <f:param value="#{sessionScope.firstName}"/>
                </h:outputFormat>
            </f:facet>
        </h:panelGrid>

    </h:form>
    <jsp:include page="bottomMatter.jsp"/>
</f:view>
</body>
</html>

code/run-time/samples/cardemo/src/main/webapp/index.jsp
<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
<meta http-equiv="refresh" content="2;url=description/index.html">
</head>

<body>

</body>
</html>